using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace JoystickInterop {
    [StructLayout(LayoutKind.Sequential)]
    public struct TM_Response {
        public VersionInfo VerInfo;  // This what I don't know how to do
        public JoystickInfo JoyInfo; // Marshal these three structures
        public CharSetInfo FontInfo; // to send the data from the dll properly
        public byte MsgID;
        public byte RetResponse;
        public byte KeyCode;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct TM_Message {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = ConstantsUsed.MAX_MSG_LEN)]
        public byte[] data;
        public int MsgLen;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct VersionInfo {
         public byte FirmwareMajVer;
         public byte FirmwareMinVer;
         public byte HardVer;           //Hardware Version
         public byte ModelType;         //Model Type
         public byte TMSchema;          //Terminal Mode Schema
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct JoystickInfo {
        public byte LeftDeflection;
        public byte RightDeflection;
        public byte UpDeflection;
        public byte DownDeflection;
        public byte CwDeflection;
        public byte CcwDeflection;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct CharSetInfo {
        public byte[] CharSetIDs;
        public byte NoOfCharSet;
    };

    public enum CharSet	{
        LATIN1_1252,
        CYRILLIC_1251,
        LATIN2_1250,
        GREEK_1253,
        ICONIC_CHARSET,
        LATIN5_1254
    };

    public static class ConstantsUsed {
        public const int MAX_MSG_LEN = 80;
    }

    public partial class TerminalMethods {

        [DllImport("terminalModeDll.dll")]
        private static extern bool ParsePacket(ref TM_Message ResponseMsg, ref TM_Response TM_ParsedInfo);

            bool result = ParsePacket(ref ResponseMsg, ref TM_ParsedInfo);

			// Do something with data set global structures for the TM_ParsedInfo...

            return result;
        }
    }

}
